Package: datasauRus
Title: Datasets from the Datasaurus Dozen
Version: 0.1.9
Authors@R: c(
    person("Colin", "Gillespie", , "colin@jumpingrivers.com", role = c("cre", "aut")),
    person("Steph", "Locke", , "stephanie.g.locke@gmail.com", role = "aut"),
    person("Alberto", "Cairo", , "alberto.cairo@gmail.com", role = "dtc"),
    person("Rhian", "Davies", , "statsrhian@gmail.com", role = "aut"),
    person("Justin", "Matejka", , "Justin.Matejka@autodesk.com", role = "dtc"),
    person("George", "Fitzmaurice", , "George.Fitzmaurice@autodesk.com", role = "dtc"),
    person("Lucy", "D'Agostino McGowan", , "ld.mcgowan@vanderbilt.edu", role = "aut"),
    person("Richard", "Cotton", , "richierocks@gmail.com", role = "ctb"),
    person("Tim", "Book", , "TimothyKBook@gmail.com", role = "ctb"),
    person("Jumping Rivers", role = "fnd")
  )
Description: The Datasaurus Dozen is a set of datasets with the same
    summary statistics. They retain the same summary statistics despite
    having radically different distributions.  The datasets represent a
    larger and quirkier object lesson that is typically taught via
    Anscombe's Quartet (available in the 'datasets' package). Anscombe's
    Quartet contains four very different distributions with the same
    summary statistics and as such highlights the value of visualisation
    in understanding data, over and above summary statistics. As well as
    being an engaging variant on the Quartet, the data is generated in a
    novel way. The simulated annealing process used to derive datasets
    from the original Datasaurus is detailed in "Same Stats, Different
    Graphs: Generating Datasets with Varied Appearance and Identical
    Statistics through Simulated Annealing" <doi:10.1145/3025453.3025912>.
License: MIT + file LICENSE
URL: https://github.com/jumpingrivers/datasauRus,
        https://jumpingrivers.github.io/datasauRus/
BugReports: https://github.com/jumpingrivers/datasauRus/issues
Depends: R (>= 3.5.0)
Suggests: dplyr, ggplot2, knitr, rmarkdown, spelling, testthat
VignetteBuilder: knitr
Encoding: UTF-8
Language: en-US
LazyData: true
RoxygenNote: 7.3.2
NeedsCompilation: no
Packaged: 2025-01-23 16:55:48 UTC; colin
Author: Colin Gillespie [cre, aut],
  Steph Locke [aut],
  Alberto Cairo [dtc],
  Rhian Davies [aut],
  Justin Matejka [dtc],
  George Fitzmaurice [dtc],
  Lucy D'Agostino McGowan [aut],
  Richard Cotton [ctb],
  Tim Book [ctb],
  Jumping Rivers [fnd]
Maintainer: Colin Gillespie <colin@jumpingrivers.com>
Repository: CRAN
Date/Publication: 2025-01-23 17:20:02 UTC
Built: R 4.3.3; ; 2025-01-24 06:23:02 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# datasauRus <img src="man/figures/logo.png" align="right" />

<!-- badges: start -->

[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![CRAN
status](https://www.r-pkg.org/badges/version/datasauRus)](https://CRAN.R-project.org/package=datasauRus)
[![R-CMD-check](https://github.com/jumpingrivers/datasauRus/workflows/R-CMD-check/badge.svg)](https://github.com/jumpingrivers/datasauRus/actions)
<!-- badges: end -->

This package wraps the awesome Datasaurus Dozen datasets. The Datasaurus
Dozen show us why visualisation is important – summary statistics can be
the same but distributions can be very different. In short, this package
gives a fun alternative to [Anscombe’s
Quartet](https://en.wikipedia.org/wiki/Anscombe%27s_quartet), available
in R as `anscombe`.

The original Datasaurus was created by Alberto Cairo. The other Dozen
were generated using simulated annealing and the process is described in
the paper “Same Stats, Different Graphs: Generating Datasets with Varied
Appearance and Identical Statistics through Simulated Annealing” by
Justin Matejka and George Fitzmaurice ([open access materials including
manuscript and
code](https://www.research.autodesk.com/publications/same-stats-different-graphs/),
[official paper](https://doi.org/10.1145/3025453.3025912)).

In the paper, Justin and George simulate a variety of datasets that the
same summary statistics to the Datasaurus but have very different
distributions.

<img src="https://damassets.autodesk.net/content/dam/autodesk/research/publications-assets/gifs/same-stats-different-graphs/DinoSequentialSmaller.gif" title="Sequential dinosaur gif" alt="Sequential dinosaur gif" width="600px" />

## Install

The latest stable version is available on CRAN

``` r
install.packages("datasauRus")
```

You can get the latest development version from GitHub, so use
{devtools} to install the package

``` r
devtools::install_github("jumpingrivers/datasauRus")
```

## Usage

You can use the package to produce Anscombe plots and more.

``` r
library("ggplot2")
library("datasauRus")
ggplot(datasaurus_dozen, aes(x = x, y = y, colour = dataset))+
  geom_point() +
  theme_void() +
  theme(legend.position = "none")+
  facet_wrap(~dataset, ncol = 3)
```

![](man/figures/datasets-1.png)<!-- -->

## Code of Conduct

Please note that the datasauRus project is released with a [Contributor
Code of
Conduct](https://jumpingrivers.github.io/datasauRus/CODE_OF_CONDUCT.html).
By contributing to this project, you agree to abide by its terms

## -----------------------------------------------------------------------------
library(datasauRus)
if (requireNamespace("dplyr")) {
  suppressPackageStartupMessages(library(dplyr))
  datasaurus_dozen %>%
    group_by(dataset) %>%
    summarize(
      mean_x    = mean(x),
      mean_y    = mean(y),
      std_dev_x = sd(x),
      std_dev_y = sd(y),
      corr_x_y  = cor(x, y)
    )
}

## ----fig.height=12, fig.width=9-----------------------------------------------
if (requireNamespace("ggplot2")) {
  library(ggplot2)
  ggplot(datasaurus_dozen, aes(x = x, y = y, colour = dataset)) +
    geom_point() +
    theme_void() +
    theme(legend.position = "none") +
    facet_wrap(~dataset, ncol = 3)
}

summary(box_plots)

## base plot

#save current settings
state = par("mar", "mfrow")

par(mfrow = c(5, 2), mar = c(1, 2, 2, 1))

nms = names(box_plots)

for (i in 1:5) {
  nm = nms[i]
  hist(box_plots[[nms[i]]],
       breaks = 100,
       main = nm)
  boxplot(box_plots[[nms[i]]],
          horizontal = TRUE)
}


#reset settings
par(state)

## ggplot
if (require(ggplot2)) {
  ggplot(box_plots, aes(x = left)) +
    geom_density()
  ggplot(box_plots, aes(x = lines)) +
    geom_density()
  ggplot(box_plots, aes(x = normal)) +
    geom_density()
  ggplot(box_plots, aes(x = right)) +
    geom_density()
  ggplot(box_plots, aes(x = split)) +
    geom_density()
}

if (require(ggplot2)) {
  ggplot(datasaurus_dozen, aes(x = x, y = y, colour = dataset)) +
    geom_point() +
    theme_void() +
    theme(legend.position = "none") +
    facet_wrap(~dataset, ncol = 3)
}

# Base R plots
state = par("mar", "mfrow")

# plot
par(mfrow = c(5, 3), mar = c(1, 2, 2, 1))

sets = sort(unique(datasaurus_dozen$dataset))

for (s in sets) {
  df = datasaurus_dozen[datasaurus_dozen$dataset == s, ]
  plot(df$x, df$y, pch = 16)
  title(s)
}

#reset settings
par(state)

if (require(ggplot2)) {
  ggplot(twelve_from_slant_long, aes(x = x, y = y, colour = dataset)) +
    geom_point() +
    theme_void() +
    theme(legend.position = "none") +
    facet_wrap(~dataset, ncol = 3)
}

# Base R Plots
state = par("mfrow", "mar")

par(mfrow = c(4, 3), mar = c(3, 2, 2, 2))

sets = sort(unique(twelve_from_slant_long$dataset))

for (s in sets) {
  df = twelve_from_slant_long[twelve_from_slant_long$dataset == s, ]
  plot(df$x, df$y, pch = 16, xlab = "", ylab = "")
  title(s)
}

par(state)

#save current settings
state = par("mar", "mfrow")

# plot
par(mfrow = c(4, 3), mar = c(1, 3, 3, 1))

nms = names(twelve_from_slant_alternate_wide)
for (i in seq(1, 23, by = 2)) {
  nm = substr(nms[i], 1, nchar(nms[i]) - 2)
  plot(twelve_from_slant_alternate_wide[[nms[i]]],
       twelve_from_slant_alternate_wide[[nms[i + 1]]],
       xlab = "", ylab = "", main = nm)
}

#reset settings
par(state)

if (require(ggplot2)) {
  ggplot(simpsons_paradox, aes(x = x, y = y, colour = dataset)) +
    geom_point() +
    theme(legend.position = "none") +
    facet_wrap(~dataset, ncol = 3)
}

# Base R Plots
state = par("mfrow")

par(mfrow = c(1, 2))

sets = unique(datasaurus_dozen$dataset)

for (i in 1:2) {
  df = simpsons_paradox[simpsons_paradox$dataset == paste0("simpson_", i), ]
  plot(df$x, df$y, pch = 16, xlab = "", ylab = "")
  title(paste0("Simpson\'s Paradox ", i))
}

par(state)

#save current settings
state = par("mar", "mfrow")

par(mfrow = c(1, 2))

plot(simpsons_paradox_wide[["simpson_1_x"]],
     simpsons_paradox_wide[["simpson_1_y"]],
     xlab = "x", ylab = "y", main = "Simpson's Paradox 1")

plot(simpsons_paradox_wide[["simpson_2_x"]],
     simpsons_paradox_wide[["simpson_2_y"]],
     xlab = "x", ylab = "y", main = "Simpson's Paradox 2")

#reset settings
par(state)

if (require(ggplot2)) {
  library(ggplot2)
  library(datasauRus)
  ggplot(datasaurus_dozen, aes(x = x, y = y, colour = dataset)) +
    geom_point() +
    theme_void() +
    theme(legend.position = "none") +
    facet_wrap(~ dataset, ncol = 3)
}

# Base R Plots
state = par("mfrow", "mar")

par(mfrow = c(5, 3), mar = c(2, 2, 2, 2))

sets = unique(datasaurus_dozen$dataset)

for (s in sets) {
  df = datasaurus_dozen[datasaurus_dozen$dataset == s, ]
  plot(df$x, df$y, pch = 16)
  title(s)
}

par(state)

#save current settings
state = par("mar", "mfrow")

# plot
par(mfrow = c(4, 3), mar = c(1, 3, 3, 1))

nms = names(twelve_from_slant_wide)
for (i in seq(1, 23, by = 2)) {
  nm = substr(nms[i], 1, nchar(nms[i]) - 2)
  plot(twelve_from_slant_wide[[nms[i]]],
       twelve_from_slant_wide[[nms[i + 1]]],
       xlab = "", ylab = "", main = nm)
}

#reset settings
par(state)

---
title: "The Datasaurus data package"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{The Datasaurus data package}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

This package wraps the awesome Datasaurus Dozen dataset, which contains [13](https://www.phrases.org.uk/meanings/Bakers-dozen.html) sets of x-y data. Each sub-dataset has five statistics that are (almost) the same in each case. (These are the mean of x, mean of y, standard deviation of x, standard deviation of y, and Pearson correlation between x and y). However, scatter plots reveal that each sub-dataset looks very different. The dataset is intended to be used to teach students that it is important to plot their own datasets, rather than relying only on statistics.

The Datasaurus was created by Alberto Cairo. Datasaurus shows us why visualisation is important, not just summary statistics.

He's been subsequently made even more famous in the paper [Same Stats, Different Graphs: Generating Datasets with Varied Appearance and Identical Statistics through Simulated Annealing](https://www.research.autodesk.com/publications/same-stats-different-graphs/) by Justin Matejka and George Fitzmaurice.

In the paper, Justin and George simulate a variety of datasets that the same summary statistics to the Datasaurus but have very different distributions. 

This package looks to make these datasets available for use as an advanced [Anscombe's Quartet](https://en.wikipedia.org/wiki/Anscombe%27s_quartet), available in R as `anscombe`.

## Usage

To see that statistics are (almost) the same for each sub-dataset, you can use `dplyr`.

```{r}
library(datasauRus)
if (requireNamespace("dplyr")) {
  suppressPackageStartupMessages(library(dplyr))
  datasaurus_dozen %>%
    group_by(dataset) %>%
    summarize(
      mean_x    = mean(x),
      mean_y    = mean(y),
      std_dev_x = sd(x),
      std_dev_y = sd(y),
      corr_x_y  = cor(x, y)
    )
}
```

To see that each sub-dataset looks very different, you can draw scatter plots.

```{r fig.height=12, fig.width=9}
if (requireNamespace("ggplot2")) {
  library(ggplot2)
  ggplot(datasaurus_dozen, aes(x = x, y = y, colour = dataset)) +
    geom_point() +
    theme_void() +
    theme(legend.position = "none") +
    facet_wrap(~dataset, ncol = 3)
}
```
